#ifndef _OPC_PROPERTIES_H
#define _OPC_PROPERTIES_H

#include <dsmalloc.h>
#include <dshashtable.h>
#include <dslock.h>

#include <opcproperty.h>

typedef struct OPCPropertiesContextT *OPCPropertiesContext;

struct OPCPropertiesContextT {
    DSMallocContext malloc;
    DSLockContext lock;
    DSHashTable id;
    OPCPropertyContext *properties;
    unsigned short maxid;
    unsigned short userid;
    unsigned short curid;
};

OPCPropertiesContext opcPropertiesCreateContext(DSMallocContext mctx);
int opcPropertiesInitContext(OPCPropertiesContext ctx, unsigned long properties_hash_size, unsigned short properties_maxid, unsigned short properties_userid);
void opcPropertiesFreeContext(OPCPropertiesContext ctx);
void opcPropertiesDestroyContext(OPCPropertiesContext ctx);

int opcPropertiesRegisterProperty(OPCPropertiesContext ctx, OPCPropertyContext property);
int opcPropertiesRegisterPropertyByType(OPCPropertiesContext ctx, const char *name, const OPCType type);
int opcPropertiesRegisterPropertyByDataType(OPCPropertiesContext ctx, const char *name, OPCDataType type, const void *attr);
OPCPropertyContext opcPropertiesFindProperty(OPCPropertiesContext ctx, const char *property);
unsigned short opcPropertiesFindPropertyId(OPCPropertiesContext ctx, const char *property);
OPCPropertyContext OpcPropertiesGetProperty(OPCPropertiesContext ctx, unsigned short id);



#endif /* _OPC_PROPERTIES_H */
