#ifndef _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H
#define _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H

#include <dsxml.h>
#include <dsmalloc.h>
#include <dslock.h>

#include <opcconfiguration.h>

typedef struct OPCFDOPCBinaryContextT *OPCFDOPCBinaryContext;

#include <opcfdopcbinarydictionary.h>


struct OPCFDOPCBinaryContextT {
    DSMallocContext malloc;

    OPCNamespaces namespaces;

    DSLockContext lock;
    
    char *dictdir;
    size_t dictdir_chars;
    
    xmlSchemaPtr schema_rep;
};

OPCFDOPCBinaryContext opcFDOPCBinaryCreateContext(DSMallocContext mctx);
int opcFDOPCBinaryInitContext(OPCFDOPCBinaryContext ctx, OPCNamespaces namespaces, const char *schema, const char *dictdir);
void opcFDOPCBinaryFreeContext(OPCFDOPCBinaryContext ctx);
void opcFDOPCBinaryDestroyContext(OPCFDOPCBinaryContext ctx);

int opcFDOPCBinaryValidateXML(OPCFDOPCBinaryContext ctx, xmlDocPtr doc);
int opcFDOPCBinaryValidateDictionary(OPCFDOPCBinaryContext ctx, OPCFDOPCBinaryDictionaryContext dctx);
OPCFDOPCBinaryDictionaryContext opcFDOPCBinaryCreateDictionaryFromMemory(OPCFDOPCBinaryContext ctx, const char *xml, unsigned long length);
OPCFDOPCBinaryDictionaryContext opcFDOPCBinaryCreateDictionary(OPCFDOPCBinaryContext ctx, const char *dictionary);

#endif /* _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H */
